'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _day = require('./day');

var _day2 = _interopRequireDefault(_day);

var _month = require('./month');

var _month2 = _interopRequireDefault(_month);

var _year = require('./year');

var _year2 = _interopRequireDefault(_year);

var _default = require('../theme/default.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import reactTrans from '../../react-trans';

// reactTrans.init();

var Menu = function (_Component) {
    _inherits(Menu, _Component);

    function Menu(props) {
        _classCallCheck(this, Menu);

        var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props));

        _this.theme = props.theme || {
            background: '#39A8BF'
        };
        var selectedDate = _this.props.selectedDate;

        _this.handleOpen = _this.handleOpen.bind(_this);
        _this.initDate = _this.initDate.bind(_this);
        _this.dayChange = _this.dayChange.bind(_this);
        _this.monthChange = _this.monthChange.bind(_this);
        _this.yearChange = _this.yearChange.bind(_this);
        _this.getMaxDays = _this.getMaxDays.bind(_this);
        var initDateObj = _this.initDate(props.selected);
        _this.handleGetDate = _this.handleGetDate.bind(_this);
        _this.state = {
            close: false,
            open: _this.props.open,
            react_trans: true,
            selectedArr: initDateObj.list,
            maxDay: initDateObj.maxDay
        };
        return _this;
    }

    //handle the datePicker open/close


    _createClass(Menu, [{
        key: 'handleOpen',
        value: function handleOpen() {
            this.setState({
                close: true
            });
        }

        //check seleted date, if undefined, then choose new Date(),and incert them into  
        //the array to be returned.

    }, {
        key: 'initDate',
        value: function initDate(selected) {
            if (typeof selected !== 'undefined' && selected !== null) {
                var dateArr = selected.split('/');
                var d = new Date(dateArr[0], dateArr[1], 0);
                return {
                    list: dateArr,
                    maxDay: d.getDate()
                };
            } else {
                var date = new Date();
                var getYear = date.getFullYear();
                var getMonth = date.getMonth() + 1;
                var getDay = date.getDate();
                var _d = new Date(getYear, getMonth, 0);
                return {
                    list: [getYear, getMonth - 1, getDay],
                    maxDay: _d.getDate()
                };
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.open) {
                this.setState({
                    close: false,
                    open: nextProps.open
                });
            } else {
                this.setState({
                    close: true,
                    open: nextProps.open
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            // reactTrans.showElement(this.div);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            // reactTrans.showElement(this.div);
        }
    }, {
        key: 'dayChange',
        value: function dayChange(day) {
            this.setState({
                selectedArr: [this.state.selectedArr[0], this.state.selectedArr[1], day]
            });
        }
    }, {
        key: 'monthChange',
        value: function monthChange(month) {
            if (month !== this.state.selectedArr[1]) {
                var maxDay = this.getMaxDays(this.state.selectedArr[0], month);
                if (this.state.selectedArr[2] > maxDay) {
                    this.setState({
                        selectedArr: [this.state.selectedArr[0], this.state.selectedArr[1], maxDay],
                        maxDay: maxDay
                    });
                } else {
                    this.setState({
                        selectedArr: [this.state.selectedArr[0], month, this.state.selectedArr[2]],
                        maxDay: maxDay
                    });
                }
            }
        }
    }, {
        key: 'yearChange',
        value: function yearChange(year) {
            if (year !== this.state.selectedArr[0]) {
                var maxDay = this.getMaxDays(year, this.state.selectedArr[1]);
                if (this.state.selectedArr[2] > maxDay) {
                    this.setState({
                        selectedArr: [year, this.state.selectedArr[1], maxDay],
                        maxDay: maxDay
                    });
                } else {
                    this.setState({
                        selectedArr: [year, this.state.selectedArr[1], this.state.selectedArr[2]],
                        maxDay: maxDay
                    });
                }
            }
        }
    }, {
        key: 'getMaxDays',
        value: function getMaxDays(year, month) {
            month = parseInt(month);
            var d = new Date(year, month, 0);
            return d.getDate();
        }
    }, {
        key: 'handleGetDate',
        value: function handleGetDate() {
            this.setState({
                close: true
            });
            if (this.props.getDate) {
                this.props.getDate(this.state.selectedArr);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var theme = this.theme;
            if (!this.state.open || this.state.close) return null;
            return _react2.default.createElement(
                'div',
                { style: _default.mainStyle, ref: function ref(div) {
                        return _this2.div = div;
                    } },
                _react2.default.createElement('div', { style: _default.maskStyle, onClick: this.handleOpen }),
                _react2.default.createElement(
                    'div',
                    { style: _default.menuStyle },
                    _react2.default.createElement(
                        'div',
                        { style: _default.menuHeaderStyle },
                        _react2.default.createElement(
                            'p',
                            { style: _default.menuHeaderFirstStyle },
                            this.state.selectedArr[0]
                        ),
                        _react2.default.createElement(
                            'p',
                            { style: _default.menuHeaderLastStyle },
                            this.state.selectedArr[1],
                            '\u6708',
                            this.state.selectedArr[2],
                            '\u65E5'
                        )
                    ),
                    _react2.default.createElement('p', { style: _default.menuLines }),
                    _react2.default.createElement(
                        'div',
                        { style: _default.menuContentStyle },
                        _react2.default.createElement(_year2.default, { selected: this.state.selectedArr[0], yearChange: this.yearChange }),
                        _react2.default.createElement(_month2.default, { selected: this.state.selectedArr[1], monthChange: this.monthChange }),
                        _react2.default.createElement(_day2.default, { selected: this.state.selectedArr[2], dayChange: this.dayChange, maxDay: this.state.maxDay })
                    ),
                    _react2.default.createElement(
                        'div',
                        { style: _default.menuFooterStyle },
                        _react2.default.createElement(
                            'p',
                            { style: _default.menuFooterButtonStyle, onClick: this.handleGetDate },
                            '\u786E\u5B9A'
                        )
                    )
                )
            );
        }
    }]);

    return Menu;
}(_react.Component);

exports.default = Menu;